package advJspFormProc;

import java.util.*;
import java.io.*;

public class AdvJspFormProc 
{
	private Vector flds=null;
	private String formName;

	public static void main(String[] args) throws IOException
	{
		AdvJspFormProc ajfp = new AdvJspFormProc();
		ajfp.start();
	}
	private void start() throws IOException
	{
		/*
			* This will generate four JSP files
			*	- reset_FormName.jsp
			*	- proc_FormName.jsp
			*	- form_FormName.jsp
			*	- disp_FormName.jsp
			* And Two Java files
			*	- FormBean_FormName.java
			*	- DasBean_FormName.java
		*/

		PrintWriter pw;

		flds = new Vector();

		BufferedReader in = new BufferedReader( new InputStreamReader(System.in));
		readDefinition(in);
		try	{in.close();}catch (Exception e) {}

		pw = new PrintWriter(new FileWriter("reset_"+formName+".jsp"), true);
		genJspReset(pw);
		try	{pw.close();}catch (Exception e) {}

		pw = new PrintWriter(new FileWriter("proc_"+formName+".jsp"), true);
		genJspProc(pw);
		try	{pw.close();}catch (Exception e) {}

		pw = new PrintWriter(new FileWriter("form_"+formName+".jsp"), true);
		genJspForm(pw);
		try	{pw.close();}catch (Exception e) {}

		pw = new PrintWriter(new FileWriter("disp_"+formName+".jsp"), true);
		genJspDisp(pw);
		try	{pw.close();}catch (Exception e) {}

		pw = new PrintWriter(new FileWriter("FormBean_"+formName+".java"), true);
		genJavaFormBean(pw);
		try	{pw.close();}catch (Exception e) {}

		pw = new PrintWriter(new FileWriter("DasBean_"+formName+".java"), true);
		genJavaDasBean(pw);
		try	{pw.close();}catch (Exception e) {}
	}


	private void readDefinition(BufferedReader in)
	{

		try
		{

			FormField f;
			String s;
			while( (s = in.readLine().trim()) != null )
			{
				if ( (s.length()) > 0 && (s.charAt(0) != '#'))
					break;
			}
			formName = StrUtil.firstCharUpper(StrUtil.strip(s));

			while( (s = in.readLine().trim()) != null )
			{
				if ( (s.length()) == 0 && (s.charAt(0) == '#'))
					continue;
				String s1 = s.substring(0, 1).toUpperCase();


				if (s1.equals("T") || s1.equals("P")) // TEXT, PASSWORD
				{
					f = new BasicFormField();
				}
				else
				{
					f = new ComplexFormField();
				}
				f.parseLine(s);
				flds.add(f);
			}
		} 
		catch (Exception e)  
		{
			// System.out.println("Main:readLine Exception");
			// e.printStackTrace();
		} 
	}

	private void genJspReset(PrintWriter pw)
	{
		getJspCopyRight("reset_", pw);

		pw.println("<jsp:useBean id='formHandler' class='formProcessing.FormBean_" + formName + "' scope='request'/>\n");
		pw.println("<% formHandler.reset(); %>\n");
		pw.println("<jsp:forward page='form_" + formName + ".jsp'/>\n");

	}

	private void genJspProc(PrintWriter pw)
	{
		getJspCopyRight("proc_", pw);

		pw.println("<jsp:useBean id='formHandler' class='formProcessing.FormBean_" + formName + "' scope='request'>");
		pw.println("\t<jsp:setProperty name='formHandler' property='*'/>\n</jsp:useBean>\n");

		pw.println("<%--\n\t* Uncomment this for Database Access Services interface");
		pw.println("<jsp:useBean id='dasHandler' class='formProcessing.DasBean_" + formName + "' scope='request'/>\n--%>\n");

		pw.println("<%\n\tif (formHandler.validate())\n\t{\n%>\n");
		pw.println("\t\t<jsp:forward page='disp_" + formName + ".jsp'/>\n<%\n");

		pw.println("\t/*\n\t* Uncomment this for Database Access Services interface");
		pw.println("\t\tdasHandler.procData(session, formHandler);\n\t*/\n");

		pw.println("\t} else {\n%>\n\t\t<jsp:forward page='form_" + formName + ".jsp'/>\n<%\n\t}\n%>\n\n");

	}

	private void genJspForm(PrintWriter pw)
	{
		getJspCopyRight("form_", pw);

		pw.println("<jsp:useBean id='formHandler' class='formProcessing.FormBean_" + formName + "' scope='request'/>\n");

		// Form Heading
		genJspHtmlHeader(pw);

		pw.println("<FORM ACTION='proc_"+formName+".jsp' METHOD=POST>");
		pw.println("<CENTER><TABLE>");

		try
		{
			Enumeration e = flds.elements();
			while (e.hasMoreElements())
			{
				String s = ((FormField)e.nextElement()).genJspForm();
				pw.println(s);
			}
		}
		catch (Exception e)  
		{
			// System.out.println("genJspForm Exception");
			// e.printStackTrace();
		} 

		pw.println("</TABLE></CENTER>\n<CENTER>\n<INPUT TYPE='SUBMIT' NAME='Submit' VALUE='Submit'>   <INPUT TYPE='RESET' NAME='Reset' VALUE='Reset'>\n</CENTER>\n</FORM></BODY></HTML>\n");
	}

	private void genJspDisp(PrintWriter pw)
	{
		getJspCopyRight("disp_", pw);

		pw.println("<jsp:useBean id='formHandler' class='formProcessing.FormBean_" + formName + "' scope='request'/>\n");

		genJspHtmlHeader(pw);

		pw.println("<CENTER><TABLE>");

		Enumeration e = flds.elements();
		while (e.hasMoreElements())
			pw.println(((FormField)e.nextElement()).genJspDisp());

		pw.println("</TABLE></CENTER>\n</BODY></HTML>\n");
	}

	private void genJavaFormBean(PrintWriter pw)
	{
		getJavaCopyRight("FormBean_", pw);

		pw.println("package formProcessing;\n\nimport java.util.*;\n\n");
		pw.println("public class FormBean_" + formName +"\n{");

		genJavaFormBeanDeclaration(pw);
		genJavaFormBeanConstructor(pw);

		pw.println("\tpublic String getErrorMsg(String s)\n\t{\n");
		pw.println("\t\tString err = (String) errors.get(s.trim());");
		pw.println("\t\treturn (err == null) ? \"\":err;");
		pw.println("\t}\n");

		genJavaFormBeanValidate(pw);
		genJavaFormBeanProperties(pw);

		pw.println("}\n\n");
	}

	private void genJavaFormBeanDeclaration(PrintWriter pw)
	{
		pw.println("\tprivate Hashtable errors;\n");
		Enumeration e = flds.elements();
		while (e.hasMoreElements())
		{
			FormField f = (FormField)e.nextElement();
			pw.print("\tprivate String ");
			if (!f.isSimpleField())
				pw.print("[] ");
			pw.println(f.getFieldName() + ";");
		}
                pw.println("");
	}

	private void genJavaFormBeanConstructor(PrintWriter pw)
	{
		pw.println("\tpublic FormBean_" + formName + "()\n\t{\n\t\treset();\n\t}\n");

		pw.println("\tpublic void reset()\n\t{\n\t\terrors = new Hashtable();\n");

		Enumeration e = flds.elements();
		while (e.hasMoreElements())
		{
			FormField f = (FormField)e.nextElement();
			if (f.isSimpleField())
				pw.println("\t\t"+f.getFieldName()+" = new String();");
			else
				pw.println("\t\t"+f.getFieldName()+" = new String[] {};");
		}

		pw.println("\t}\n");
	}

	private void genJavaFormBeanValidate(PrintWriter pw)
	{
		pw.println ("\tpublic boolean validate()\n\t{\n\t\tboolean allOk=true;\n");

		Enumeration e = flds.elements();
		while (e.hasMoreElements())
		{
			FormField f = (FormField)e.nextElement();
			if (f.getRequired())
			{
				if (f.isSimpleField())
					pw.println("\t\tif ("+f.getFieldName()+".equals(\"\"))\n\t\t{");
				else
					pw.println("\t\tif ("+f.getFieldName()+".length == 0)\n\t\t{");
					
				pw.println("\t\t\terrors.put(\""+f.getFieldName()+"\", \" ***This field is required!\");");

				if (f.isSimpleField())
					pw.println("\t\t\t"+f.getFieldName()+" = \"\";");
				else
					pw.println("\t\t\t"+f.getFieldName()+" = new String[] {};");

				pw.println("\t\t\tallOk = false;\n\t\t}\n");
			}
		}
		pw.println("\t\treturn allOk;\n\t}\n");
	}

	private void genJavaFormBeanProperties(PrintWriter pw)
	{
		Enumeration e = flds.elements();
		while (e.hasMoreElements())
		{
			FormField f = (FormField)e.nextElement();
			pw.println(f.genJavaFormBeanProperties());
		}
	}


	private void genJavaDasBean(PrintWriter pw)
	{
		getJavaCopyRight("DasBean_", pw);

		pw.println("package formProcessing;\n\n");
		pw.println("import java.util.*;");
		pw.println("import java.sql.*;");
		pw.println("import javax.servlet.*;");
		pw.println("import javax.servlet.http.*;");
		pw.println("import javax.servlet.jsp.*;\n");

		pw.println("import dasSupport.*;\n\n");

		pw.println("public class DasBean_" + formName +" extends DasRowProcessing\n{");

		pw.println("\tprivate HttpSession session=null;\n\tprivate FormBean_"+ formName +" formHandler=null;\n");

		pw.println("\tpublic DasBean_" + formName +"()\n\t{\n\t}\n");

		genJavaDasBeanProcData(pw);
		genJavaDasBeanMisc(pw);

		pw.println("}\n\n");
	}

	private void genJavaDasBeanProcData(PrintWriter pw)
	{
		// DataAccess is using StopreProcedure: sp_FormName(...)
		pw.println("\tpublic void procData(HttpSession ses, FormBean_" + formName + " hdlr)\n\t{");
		pw.println("\t\ttry\n\t\t{");

		pw.println("\n\t\t\t// DataAccess is using StopreProcedure: sp_FormName(...)\n");

		pw.println("\t\t\tsession=ses;\n\t\t\tformHandler = hdlr;");
		pw.println("\t\t\tDasApiInterface das = (DasApiInterface)session.getAttribute(\"DataAccessService\");");

		pw.print("\n\t\t\tdas.das(\"das_" + formName + "\", this, \"{ call sp_" + formName +"(");

		// Generate the parameter list:
		boolean firstParam = true;
		Enumeration e = flds.elements();
		while(e.hasMoreElements())
		{
			FormField f = (FormField)e.nextElement();
			if (!firstParam)
				pw.print(", ");
			pw.print("?"); // for oracle, pw.print(f.getFieldName() + "=>?");
			firstParam = false;
		}
		pw.println(")}\", true);");

		pw.println("\t\t} catch (Exception e) { e.printStackTrace(); }\n\t}\n");
	}


	private void genJavaDasBeanMisc(PrintWriter pw)
	{
		// DataAccess is using StopreProcedure: sp_FormName(...)
		// Genenerate the rowProcessing Function
		pw.println("\tpublic boolean rowProcessing(String tag, ResultSet rs, ResultSetMetaData md) throws Exception\n\t{");

		pw.println("\n\t\t// Dummy, no code generated for this. IT IS YOUR JOB.\n\n\t\treturn false;");

		pw.println("\t}\n");

		// Generate bindParam Function
		pw.println("\tpublic void bindParam(String tag, PreparedStatement stmt) throws Exception\n\t{");

		pw.println("\n\t\t// Keep it simple, I only generate the setString(i, s)\n");

		Enumeration en = flds.elements();
		for (int i=0; en.hasMoreElements(); i++ )
		{
			FormField f = (FormField)en.nextElement();
			if (f.isSimpleField())
				pw.println("\t\tstmt.setString(" + i +", formHandler.get" + f.getPropertyName() + "() );");
			else
				pw.println("\t\tstmt.setString(" + i +", DasUtil.join(\"~\", formHandler.get" + f.getPropertyName() + "()) );");
		}
		pw.println("\t}\n");
	}

	private void getJavaCopyRight(String prefix, PrintWriter pw)
	{
		pw.println("/*\n\t" + prefix + formName + ".java:\tGenerated by AdvJspFormProc\n");
		pw.println("\tReference: \"Advance Form Processing Using JSP\" by Govind Seshadri");
		pw.println("\t\twww.javaworld.com March 2000");
		pw.println("\t\thttp://www.javaworld.com/javaworld/jw-03-2000/jw-0331-ssj-forms.html");
		pw.println("*/\n\n");
	}

	private void getJspCopyRight(String prefix, PrintWriter pw)
	{
		pw.println("<%--\n\t" + prefix + formName + ".jsp:\tGenerated by AdvJspFormProc\n");
		pw.println("\tReference: \"Advance Form Processing Using JSP\" by Govind Seshadri");
		pw.println("\t\twww.javaworld.com March 2000");
		pw.println("\t\thttp://www.javaworld.com/javaworld/jw-03-2000/jw-0331-ssj-forms.html");
		pw.println("\t******:\tThere is no guarantee for the generated code to work at all!");
		pw.println("--%>\n\n");
	}


	private void genJspHtmlHeader(PrintWriter pw)
	{
		pw.println("<HTML>\n\n<HEAD>");
		pw.println("\t<META HTTP-EQUIV='Content-Type' CONTENT='text/html;CHARSET=iso-8859-1'>");
		pw.println("\t<META NAME='GENERATOR' Content='AdvJspFormProc'>");
		pw.println("\t<TITLE>" + formName + "</TITLE>");
		pw.println("\t<LINK REL='stylesheet' TYPE='text/css' HREF='stylesheet/default.css'>");
		pw.println("\n</HEAD>\n\n<BODY>\n");
	}
}
