package advJspFormProc;

import java.util.*;
import java.io.*;

public class BasicFormField implements FormField {

	private String	type = null;
	private String	name = null;
	private String	label = null;
	private String	fieldName = null;
	private String	propertyName = null;
	private boolean	required = false;
	private boolean	multiSelection = false;
	private boolean isTextArea = false;

	private Vector	additionalValues = null;

	BasicFormField() // Constructor
	{
		String	type = new String();
		String	name = new String();
		String	label = new String();
		String	fieldName = new String();
		String	propertyName = new String();
		boolean	required = false;
		boolean	multiSelection = false;
		boolean isTextArea = false;
		additionalValues = new Vector();
	}


	public void parseLine(String line) 
	{
		String p;
		StringTokenizer st = new StringTokenizer(line, "~");
		try 
		{
			type = st.nextToken().trim().toUpperCase();
			if ( type.equals("TEXTAREA") )
				isTextArea  =  true;

			name = StrUtil.strip(st.nextToken());
			fieldName = StrUtil.firstCharLower(name);
			propertyName = StrUtil.firstCharUpper(name);

			label = st.nextToken().trim();

			if (st.nextToken().toUpperCase().charAt(0) == 'Y')
				required = true;

			if (st.nextToken().toUpperCase().charAt(0) == 'Y')
				multiSelection = true;

			while( (p = st.nextToken().trim()) != null )
			{
				if (p.length() > 0)
				   additionalValues.add(p);
			}
		} 
		catch (Exception e)  
		{
			// IGNORE THIS EXCEPTION: System.out.println("parseLine Error");
			// e.printStackTrace();
		} 
		// System.out.println(toString()); // ReDisplay the data
	}


	final public String toString() 
	{
		StringBuffer sb = new StringBuffer(); 
		sb.append("INPUT TYPE\t[").append(getType())
                  .append("]\nFIELD NAME\t[").append(getFieldName())
                  .append("]\nFIELD LABEL\t[").append(getLabel())
                  .append("]\nREQUIRED\t[").append(getRequired())
                  .append("]\nMULTIPLE\t[").append(getMultiSelection()).append("]\n");
		Enumeration e = additionalValues.elements();
		while (e.hasMoreElements())
                	sb.append("\t*\t[").append(e.nextElement()).append("]\n");

		return( sb.toString() ); 
	}

	final public String getType() { return type; }

	final public String getFieldName() { return fieldName; }

	final public String getPropertyName() { return propertyName; }

	final public String getLabel() { return label; }

	final public boolean getRequired() { return required; }

	final public boolean getMultiSelection() { return multiSelection; }

	final public Vector getAdditionalValues() { return additionalValues; }



	public String genJspForm()
	{

		StringBuffer sb = new StringBuffer();

		sb.append( "\n<TR><TD VALIGN='TOP'>\n\t<B>" );

		if ( getRequired() == true )
			sb.append( "<SUP>*</SUP>   " );

		sb.append( getLabel() )
		  .append( "   <ERRMSG><%=formHandler.getErrorMsg(\"" )
		  .append( getFieldName() )
		  .append( "\")%></ERRMSG></B><BR>\n" );

        	// <INPUT TYPE="TEXT" NAME="Text" SIZE="26" VALUE="Text Value">
        	// <INPUT TYPE="PASSWORD" NAME="Password" SIZE="26"> VALUE="Passwd Value"
        	// <TEXTAREA NAME="TextArea" ROWS="7" COLS="35">Multi Line Text</TEXTAREA>
		if (isTextArea)
			sb.append("\t<TEXTAREA NAME='" )
			  .append( getFieldName() )
			  .append( "' ROWS=8 COLS=50><%=formHandler.get")
			  .append( getPropertyName() )
			  .append( "()%></TEXTAREA>" );
		else
			sb.append( "\t<INPUT TYPE='" )
		  	  .append( getType() )
		  	  .append( "' NAME='" )
			  .append( getFieldName() )
			  .append( "' SIZE=26 VALUE='<%=formHandler.get" )
			  .append( getPropertyName() )
			  .append( "()%>'>" );

		sb.append( "<BR>\n</TD></TR>\n" );

		return sb.toString();
	}

	public String genJspDisp()
	{
		StringBuffer sb = new StringBuffer();

		sb.append( "\n<TR><TD VALIGN='TOP'><B>" );
		if ( getRequired() == true )
			sb.append( "<SUP>*</SUP> ");
		sb.append( getLabel() )
		  .append( "\n\t</B><BR>\n" )
		  .append( "\t<%=formHandler.get" )
		  .append( getPropertyName() )
		  .append( "()%>\n</TD></TR>\n" );

		return sb.toString();
	}

	public String genJavaFormBeanProperties()
	{
		StringBuffer sb = new StringBuffer();

		sb.append( "\tpublic String get")
		  .append( getPropertyName() )
		  .append( "()\n\t{\n\t\treturn " )
		  .append( getFieldName() )
		  .append( ";\n\t}\n\n" )

		  .append( "\tpublic void set" )
		  .append( getPropertyName() )
		  .append( "(String s)\n\t{\n\t\t" )
		  .append( getFieldName() )
		  .append( " = s;\n\t}\n\n" );

		return sb.toString();
	}

	public boolean isSimpleField()
	{
		return true;
	}
	


}
