package advJspFormProc;

import java.util.*;
import java.io.*;

public class ComplexFormField extends BasicFormField 
{
	private boolean isListBox = false;


	public String genJspForm()
	{
		if ( getType().equals("SELECT") )
			isListBox = true;

		StringBuffer sb = new StringBuffer();

		sb.append( "\n<TR><TD VALIGN='TOP'>\n\t<B>" );

		if ( getRequired() == true )
			sb.append( "<SUP>*</SUP>   " );

		sb.append( getLabel() )
		  .append( "   <ERRMSG><%=formHandler.getErrorMsg(\"" )
		  .append( getFieldName() )
		  .append( "\")%></ERRMSG></B><BR>\n" );

		// <SELECT NAME="Selection" SIZE=5 MULTIPLE>
		if ( isListBox )
		{
			sb.append( "\t<SELECT NAME='")
			  .append( getFieldName() )
			  .append( "' SIZE=6");
			if ( getMultiSelection() )
				sb.append(" MULTIPLE");
			sb.append("> <%-- remove SIZE=6 for combobox --%>\n" );
		}

		Enumeration e = getAdditionalValues().elements(); 

		while (e.hasMoreElements()) 
		{

			String v = (String)e.nextElement();
			if ( isListBox )
			{
				// <OPTION SELECTED>Option 1</OPTION>
				sb.append( "\t<OPTION <%=formHandler.isSelected" )
				  .append( getPropertyName() )
				  .append( "(\"" )
				  .append( v )
				  .append( "\")%>>" )
				  .append( v )
				  .append( "</OPTION><BR>\n" );
			}
			else
			{
				// <INPUT TYPE="CHECKBOX" NAME="use" VALUE="Ada 95"  CHECKED>Ada 95<BR>
				// <INPUT TYPE="RADIO" NAME="Radio" VALUE="Radio" CHECKED>ABC<BR>
				sb.append( "\t<INPUT TYPE='" )
				  .append( getType() )
				  .append( "' NAME='" )
				  .append( getFieldName() )
				  .append( "' VALUE='" )
				  .append( v )
				  .append( "' <%=formHandler.isSelected" )
				  .append( getPropertyName() )
				  .append( "(\"" )
				  .append( v )
				  .append( "\")%>>" )
				  .append( v )
				  .append( "<BR>\n" );
			}
		}
		if ( isListBox )
			sb.append("\t</SELECT>\n");

		sb.append( "<BR>\n</TD></TR>\n" );

		return sb.toString();
	}

	public String genJspDisp()
	{
		StringBuffer sb = new StringBuffer();

		sb.append( "\n<TR><TD VALIGN='TOP'><B>" );
		if ( getRequired() == true )
			sb.append( "<SUP>*</SUP> ");
		sb.append( getLabel() )
		  .append( "</B><BR>\n" )
		  .append( "<%\n\t{\n\tString [] ss=formHandler.get" )
		  .append( getPropertyName() )
		  .append( "();\n" )
		  .append( "\tif(ss.length > 0)\n\t{\n" )
		  .append( "\t\tout.println(\"<ul>\");\n" )
		  .append( "\t\tfor (int i=0; i<ss.length; i++)\n" )
		  .append( "\t\t\tout.println(\"<li>\"+ss[i]);\n" )
		  .append( "\t\tout.println(\"</ul>\");\n" )
		  .append( "\t}\n\telse\n\t\tout.println(\"Nothing was selected\");\n\t}\n%>\n</TD></TR>\n" );

		return sb.toString();
	}

	public String genJavaFormBeanProperties()
	{
		StringBuffer sb = new StringBuffer();

		sb.append( "\tpublic String[] get" )
		  .append( getPropertyName() )
		  .append( "()\n\t{\n\t\treturn " )
		  .append( getFieldName() )
		  .append( ";\n\t}\n\n" )

		  .append( "\tpublic void set" )
		  .append( getPropertyName() )
		  .append( "(String[] s)\n\t{\n\t\t" )
		  .append( getFieldName() )
		  .append( " = s;\n\t}\n\n" )

		  .append( "\tpublic String isSelected" )
		  .append( getPropertyName() )
		  .append( "(String s)\n\t{\n" )
		  .append( "\t\tboolean notfound=true;\n")
		  .append( "\t\tif (" )
		  .append( getFieldName() )
		  .append( ".length > 0)\n\t\t{\n" )
		  .append( "\t\t\tfor(int i=0; i<" )
		  .append( getFieldName() )
		  .append( ".length; i++)\n\t\t\t{\n" )
		  .append( "\t\t\t\tif (" )
		  .append( getFieldName() )
		  .append( "[i].equals(s))\n\t\t\t\t{\n\t\t\t\t\tnotfound = false;\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t}\n\t\t}\n")
		  .append( "\t\tif (notfound)\n\t\t\treturn \"\";\n\n");

		if ( isListBox )
			sb.append( "\t\treturn \"SELECTED\";\n");
		else
			sb.append( "\t\treturn \"CHECKED\";\n");

		sb.append("\t}\n\n");

		return sb.toString();
	}
	

	public boolean isSimpleField()
	{
		return false;
	}

}
