package dasSupport;

import java.sql.*;  

// ***************************************************************************
public class DasApi implements DasApiInterface
{
	private Connection conn=null;
	public void setConnection(Connection c) {conn = c;}
	public Connection getConnection() { return conn; }
	public void releaseConnection(Connection c){} // Not support JdbcPool

	public void das(String tag, DasRowProcessingInterface proc, String sql, boolean isSp) throws Exception
	{
		Connection conn = getConnection();
		PreparedStatement stmt;
		ResultSet rs;
		try
		{
			if ( isSp )
				stmt = conn.prepareCall(sql);  // for Stored Procedure, Function
			else
				stmt = conn.prepareStatement(sql); // for Plain SQL

			proc.bindInputParam(tag, stmt);

			boolean qry = stmt.execute();

			if ( isSp )
				rs = getSpResultSet(tag, stmt, proc);
			else
				rs = stmt.getResultSet(); 

			if ( (rs != null) && (proc != null) )
			{
				ResultSetMetaData md = rs.getMetaData();
				while (rs.next() &&  proc.procResult(tag, rs, md)); // Process the Result
				rs.close();
			}

			stmt.close();
			conn.commit();
		}
		catch (Exception e) 
		{
			throw e;
		}
		try{rs.close();}catch (Exception e) {} // Make sure rs is closed
		try{stmt.close();}catch (Exception e) {} // Make sure stmt is closed

		releaseConnection(conn);  // to be friendly for using with the JdbcPool
	}

	private ResultSet getSpResultSet(String tag, PreparedStatement stmt, DasRowProcessingInterface proc)
	{
		// Default: Not Oracle Specifi
		// in Oracle: proc.bindOutputParam(tag, stmt);
		ResultSet rs = null;
	
		try{rs = proc.bindOutputParam(tag, stmt);} catch (Exception e) {}
	
		return rs;
	}
}

