package dasSupport;

import java.sql.*;

// ***************************************************************************
public class DasRowProcessing implements DasRowProcessingInterface
{
	public boolean procResult(String tag, ResultSet rs, ResultSetMetaData md) throws Exception
	{
		return false; // Default, Do care about the result
	}

  public void bindInputParam(String tag, PreparedStatement stmt) throws Exception
	{
		// Default, no parameter.
	}
  public ResultSet bindOutputParam(String tag, PreparedStatement stmt) throws Exception
	{
		return stmt.getResultSet();
		// Default: just return the ResultSet
	}

}

/* 
 * Comment on bindInputParam:
 * You should set the input parameter as follow.
 * The "pos" starts with 1 for the first parameter
 *	stmt.setLong(pos, ((Long)o).longValue());
 *	stmt.setBoolean(pos, ((Boolean)o).booleanValue());
 *	stmt.setDate(pos, (java.sql.Date)o);
 *	stmt.setDouble(pos, ((Double)o).doubleValue());
 *	stmt.setFloat(pos, ((Float) o).floatValue());
 *	stmt.setInt(pos, ((Integer)o).intValue());
 *	stmt.setShort(pos, ((Short)o).shortValue());
 *	stmt.setTime(pos, (java.sql.Time)o);
 *	stmt.setString(pos, (String)o);
 *	stmt.setString(pos, o.toString());
 *
 * Comment on bindOutParam:
 * For Oracle Function.  Function returning resultset cannot be handled
 *	return (ResultSet) ((CallableStatement)stmt).getObject(1);
 * For Oracle Stored Procedure, where the "pos" is the outposition.
 *	return (ResultSet) ((CallableStatement)stmt).getObject(pos);
 */
